#include<bits/stdc++.h>
#define ll long long
const int nmax=1e4+1;
using namespace std;
int n,dos[4],ulaz[nmax][2],izlaz[nmax][4],cnt;
char a[2];
bool p;
int main()
{
	cin >> n;
	for(int i=0;i<4;i++)cin >> dos[i];
	for(int i=0;i<n;i++)
	{
		cin >> a >> ulaz[i][1];
		if(a[0]=='A' && a[1]=='B')ulaz[i][0]=3;
		else if(a[0]=='A')ulaz[i][0]=1;
		else if(a[0]=='B')ulaz[i][0]=2;
		else ulaz[i][0]=0;	
	}
	for(int j=0;j<4;j++)
	{
		for(int i=0;i<n;i++)
		{
			if(ulaz[i][0]==j)
			{
				if(j==2 && cnt==1)cnt ++;
				while(dos[cnt]-ulaz[i][1]<0 && cnt<=j)
				{
					izlaz[i][cnt]=dos[cnt];
					ulaz[i][1]-=dos[cnt];
					cnt++;
					if(j==2 && cnt==1)cnt ++;
				}
				if(cnt>j)
				{
					cout << "nemoguce\n";
					p=1;
				}
				izlaz[i][cnt]=ulaz[i][1];
				dos[cnt]-=ulaz[i][1];
			}
		}
	}
	if(!p)
	{
		cout << "moguce\n";
		for(int i=0;i<n;i++)
		{
			for(int j=0;j<4;j++)cout << izlaz[i][j] << " ";
			cout << "\n";
		}
	}
	
}